﻿Imports Microsoft.VisualBasic

Public Class ModelFacade

    Public Function createClaim(ByVal dto As ClaimFormDTO) As Claim
        Dim claim As Claim = New Claim()
        REM we only create a policy here because we do not yet use a database
        REM more realistically, the Policy would already exist and need to be retrieved
        Dim policy As Policy = New Policy()
        ' we must set up the relationship between Claim and Policy
        ' before attempting to generate the reference, because the 
        ' ReferenceGenerator uses properties from both classes
        claim.Policy = policy
        claim.Policy.Number = dto.PolicyNumber
        claim.Policy.Type = dto.PolicyType
        claim.Amount = dto.ClaimAmount
        claim.Description = dto.ClaimDescription
        claim.DateOfClaim = DateTime.Now
        claim.IsApproved = False
        Dim generator As ReferenceGenerator = New ReferenceGenerator()
        Dim reference As String = generator.getReference(claim)
        claim.Reference = reference
        Return claim
    End Function

    Public Function getQuote(ByVal dto As BuildingsDTO) As Double
        Dim quoter As QuoteProcessor = New QuoteProcessor()
        Return quoter.getBuildingsQuote(dto)
    End Function

    Public Function getQuote(ByVal dto As ContentsDTO) As Double
        Dim quoter As QuoteProcessor = New QuoteProcessor()
        Return quoter.getContentsQuote(dto)
    End Function

End Class
